# Project in Bioinformatics

## Purpose
The purpose of this project, is to implement and code the 3D HP-model for protein folding.
<br>
The codebase is primarily written to explore the limitations of exhaustive search in the 3D HP-model, as well as implement and experiment a 3/8th approximation algorithm for the model. Furthermore to analyse the algorithm, we have implemented a fitting visualization for proteins folded under the 3D HP-model by using OpenGL, to write our own 3D visualization.
<br>
The project and codebase is focused on the article "Fast protein folding in the hydrophobic-hydrophilic model within three-eights of optimal" (doi: 10.1089).

## Cloning the project and important notes
If you want to test the project, and write your own specific HP model, and fold it using the algorithm, you will first need to clone the repository.
<br>
While we have included most of the needed libraries and packages inside the "third_party" directory, there are some "find_package" statements inside the CMakeList.txt, meaning that you are required to download some of the packages yourself. If you need to use OpenGL, and you have a MacOS device with brew installed, you can type brew install glfw in the terminal. Furthermore you might still be required to also install glm (brew install glm)

brew installed, this is relatively simple, as one can just do brew install glfw. For some reason GLM is not cooperating with some MACOS versions and therefore brew install GLM could also be necessary.
<br>
<br>
Once all of this is done, make sure to reload the CMake project, and build, and you should be good to go :) 
## Project structure
The project has three main directories
- opengl
- src
- test
<br>
<br>
The opengl directory, is the folder that is responsible for all visualization code, which means that it is the part of the code, where you can run our 3D visualization, input a HPModel or a json input, and then see the visualized fold.
<br>
<br>
The src directory, is the folder responsible for all HPModel implementation code. This means that all of our folding algorithm, HPModel implementation in 3D, and anything else that is implementation-relevant, is located in here.
<br>
<br>
The test directory, is the folder responsible for using the gtest suite for testing everything we have. This includes the opengl application, json encoder, implementation of algorithm and HPModel, etc. GSUITE should work out of the box, upon cloning the project, as it is included in the "third_part" library