//
// Created by William on 23/10/2024.
//

#ifndef BIOINFORMATIKPROJEKT_FILECACHEMANAGER_H
#define BIOINFORMATIKPROJEKT_FILECACHEMANAGER_H

#include <string>
#include "LongTermCacheData.h"

enum StrategyType {BRUTE_FORCE};
enum SequenceStatus {OPTIMAL_FOUND, IN_PROGRESS, NOT_FOUND};
static const std::string SequenceNames[] = {"OPTIMAL_FOUND", "IN_PROGRESS", "NOT_FOUND"};
static const std::string StrategyNames[] = {"BRUTE_FORCE"};
SequenceStatus getSequenceStatus(const std::string& sequence, StrategyType strategyType);
void saveSequence(const std::string& sequence, SequenceStatus status, StrategyType strategyType, const std::string& folds, int score);
void saveSequence(const std::string& sequence, StrategyType strategyType, int score, LongTermCacheData data);
LongTermCacheData loadSequence(const std::string& sequence, StrategyType type);
std::vector<std::string> getSequencesToDo();
#endif //BIOINFORMATIKPROJEKT_FILECACHEMANAGER_H
